# coding: utf-8

"""
    Workplace Console API

    API for managing email and workplace service subscriptions.

    The version of the OpenAPI document: v1
    Contact: support@truehost.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Union
from workplace_client.models.dns_info_create200_response_found_dns import DnsInfoCreate200ResponseFoundDns
from typing import Optional, Set
from typing_extensions import Self

class DnsInfoCreate200Response(BaseModel):
    """
    DnsInfoCreate200Response
    """ # noqa: E501
    score: Union[StrictFloat, StrictInt]
    message: StrictStr
    domain: StrictStr
    all_dns_score: Union[StrictFloat, StrictInt]
    found: Union[StrictFloat, StrictInt]
    total: Union[StrictFloat, StrictInt]
    missing_dns: List[StrictStr]
    other_missing_dns: List[StrictStr]
    found_dns: DnsInfoCreate200ResponseFoundDns
    error: List[StrictStr]
    __properties: ClassVar[List[str]] = ["score", "message", "domain", "all_dns_score", "found", "total", "missing_dns", "other_missing_dns", "found_dns", "error"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DnsInfoCreate200Response from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of found_dns
        if self.found_dns:
            _dict['found_dns'] = self.found_dns.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DnsInfoCreate200Response from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "score": obj.get("score"),
            "message": obj.get("message"),
            "domain": obj.get("domain"),
            "all_dns_score": obj.get("all_dns_score"),
            "found": obj.get("found"),
            "total": obj.get("total"),
            "missing_dns": obj.get("missing_dns"),
            "other_missing_dns": obj.get("other_missing_dns"),
            "found_dns": DnsInfoCreate200ResponseFoundDns.from_dict(obj["found_dns"]) if obj.get("found_dns") is not None else None,
            "error": obj.get("error")
        })
        return _obj


