# coding: utf-8

"""
    Workplace Console API

    API for managing email and workplace service subscriptions.

    The version of the OpenAPI document: v1
    Contact: support@truehost.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class WorkplaceCreateEmails(BaseModel):
    """
    WorkplaceCreateEmails
    """ # noqa: E501
    emails: List[Annotated[str, Field(min_length=1, strict=True)]]
    domain_name: Annotated[str, Field(min_length=1, strict=True, max_length=255)]
    subscription: Annotated[int, Field(strict=True, ge=0)]
    new_subscription: StrictBool
    display_name: Annotated[str, Field(min_length=1, strict=True)]
    user_password: Annotated[str, Field(min_length=1, strict=True)]
    email_quota: Annotated[int, Field(strict=True, ge=0)]
    client_id: Annotated[int, Field(strict=True, ge=0)]
    __properties: ClassVar[List[str]] = ["emails", "domain_name", "subscription", "new_subscription", "display_name", "user_password", "email_quota", "client_id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of WorkplaceCreateEmails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of WorkplaceCreateEmails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "emails": obj.get("emails"),
            "domain_name": obj.get("domain_name"),
            "subscription": obj.get("subscription"),
            "new_subscription": obj.get("new_subscription"),
            "display_name": obj.get("display_name"),
            "user_password": obj.get("user_password"),
            "email_quota": obj.get("email_quota"),
            "client_id": obj.get("client_id")
        })
        return _obj


